<?php

namespace HighWayPro\App\Components;

use HighWayPro\Original\Presentation\Component;
use Highwaypro\App\Data\Model\Preferences\UrlPreferences;

Class HTMLRedirectionMarkup extends Component
{
    protected $file = 'hTMLRedirectionMarkup.php';

    public function __construct(array $data)
    {
        $this->data = (object) $data;
    }

    public function getTargetURL()
    {
        return $this->data->targetURL;   
    }

    public function getReferrerPolicy()
    {
        return $this->data->referrerPolicy;
    }

    public function getRelAttributes()
    {
        if ($this->data->referrerType && $this->data->referrerType->is(UrlPreferences::REFERER_TYPE_HIDE)) {
            return 'noreferrer nofollow';
        }
    }

    public function getTrackingScripts()
    {
        return $this->data->trackingScripts;   
    }

    public function hasTrackingScripts()
    {
        return trim($this->getTrackingScripts());   
    }
    
}