<?php

namespace Highwaypro\App\Data\Model\Preferences;

use HighWayPro\App\HighWayPro\Texts\Dashboard\PreferencesText;
use HighWayPro\Original\Collections\Collection;
use HighwayPro\Original\Collections\JSONMapper;
use HighwayPro\Original\Collections\Mapper\Mappable;
use HighwayPro\Original\Collections\Mapper\Types;
use Highwaypro\App\Data\Model\Preferences\Preferences;

Class DashboardPreferences extends Preferences
{
    static public function fields()
    {
        return new Collection([
            'tourIsEnabled'  => Types::BOOLEAN()->withDefault(true),
            'state:urls:sidebar:orderType' => Types::STRING()->withDefault('GROUP_BY_TYPE')
                                                             ->allowed([
                                                                 'NEWEST', 
                                                                 'OLDEST', 
                                                                 'GROUP_BY_TYPE',
                                                             ]),
            'state:urls:sidebar:closedTypeGroupIDs' => Types::COLLECTION()
            /*'state' => [
                'URLs' => [
                    'sidebar' => [
                        'closedTypeGroups' => Types::COLLECTION()
                    ]
                ]
            ]*/
        ]);   
    }

    protected function getMap()
    {
        return static::fields()->asArray();
    }
}