<?php

namespace HighWayPro\App\HighWayPro\HTTP\Requests\UrlExtra;

use HighWayPro\App\HighWayPro\HTTP\Request;
use HighWayPro\Original\Collections\Mapper\Types;
use HighwayPro\App\Data\Model\UrlExtra\UrlExtra;
use HighwayPro\App\Data\Model\Urls\Url;

Class UrlExtraUpdateRequest extends Request
{
    public function map()
    {
        return [
            'url' => Url::fields()->only(['id'])->asArray(),
            'urlExtra' => [
                'value' => Types::ANY()->escape(Types::returnValueCallable())
            ],//UrlExtra::fields()->only(['value'])->asArray(),
            'fieldToUpdate' => Types::STRING
        ];
    }    

    public function __construct($path = '')
    {
        parent::__construct($path);

        (object) $valueType = UrlExtra::valueMaps()->get($this->data->fieldToUpdate->get());

        if ($valueType instanceof Types) {
            $this->data->urlExtra->value = $valueType->castToExpectedType($this->data->urlExtra->value);
        }
    }
    
}