<?php

namespace HighWayPro\App\Installators;

use HighWayPro\App\Data\Settings\Settings;
use HighWayPro\Original\Data\Drivers\WordPressDatabaseDriver;
use HighWayPro\Original\Environment\Env;
use HighWayPro\Original\Installation\Installator;

Class ConcreteInstallator
{
    protected $applicationDatabase;

    public function __construct()
    {
        (string) $ApplicationDatabase = Env::settings()->schema->applicationDatabase;

        $this->applicationDatabase = new $ApplicationDatabase(new WordPressDatabaseDriver);   
    }
    
    public function install()
    {
        $this->applicationDatabase->install();
    }

    public function update()
    {
        $this->applicationDatabase->update();   
    }
}